﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

//Custom using statements
using System.Data.SqlClient;
using System.Configuration;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            //Hide the crystal report viewer
            CrystalReportViewer1.Visible = false;
        }
        else
        {
            //If this is a postback the rebind the report so the paging works.
            if (CrystalReportViewer1.Visible == true)
            {
                //Rebind the report.
                BindReport();
            }
        }
    }
    
    protected void btnPreview_Click(object sender, EventArgs e)
    {
        BindReport();

        CrystalReportViewer1.Visible = true;
    }
    public void BindReport()
    {
        ReportDocument report = new ReportDocument();
        report.Load(Server.MapPath("SubReport.rpt"));

        SetTableLocation(report.Database.Tables, "YourServer", "AdventureWorksLT");

        SetTableLocation(report.Subreports[0].Database.Tables, "YourServer", "AdventureWorks");

        CrystalReportViewer1.ReportSource = report;
    }

    private void SetTableLocation(Tables tables, string server, string database)
    {
        ConnectionInfo connectionInfo = new ConnectionInfo();

        connectionInfo.ServerName = server;
        connectionInfo.DatabaseName = database;
        connectionInfo.UserID = "aspalliance";
        connectionInfo.Password = "aspalliance";

        foreach (CrystalDecisions.CrystalReports.Engine.Table table in tables)
        {
            TableLogOnInfo tableLogOnInfo = table.LogOnInfo;
            tableLogOnInfo.ConnectionInfo = connectionInfo;
            table.ApplyLogOnInfo(tableLogOnInfo);
        }
    }

}
